// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

/**
 * Protobuf type {@code dsepractice.chinese.v1alpha1.GameSessionData}
 */
public  final class GameSessionData extends
    com.google.protobuf.GeneratedMessageLite<
        GameSessionData, GameSessionData.Builder> implements
    // @@protoc_insertion_point(message_implements:dsepractice.chinese.v1alpha1.GameSessionData)
    GameSessionDataOrBuilder {
  private GameSessionData() {
    paragraphs_ = emptyProtobufList();
  }
  public interface ParagraphOrBuilder extends
      // @@protoc_insertion_point(interface_extends:dsepractice.chinese.v1alpha1.GameSessionData.Paragraph)
      com.google.protobuf.MessageLiteOrBuilder {

    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @return A list containing the segments.
     */
    java.util.List<java.lang.String>
        getSegmentsList();
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @return The count of segments.
     */
    int getSegmentsCount();
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param index The index of the element to return.
     * @return The segments at the given index.
     */
    java.lang.String getSegments(int index);
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param index The index of the element to return.
     * @return The segments at the given index.
     */
    com.google.protobuf.ByteString
        getSegmentsBytes(int index);

    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    java.util.List<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> 
        getOptionsSequenceList();
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    gg.dsepractice.chinese.v1alpha1.GameSessionData.Option getOptionsSequence(int index);
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    int getOptionsSequenceCount();

    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @return A list containing the startTips.
     */
    java.util.List<java.lang.String>
        getStartTipsList();
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @return The count of startTips.
     */
    int getStartTipsCount();
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param index The index of the element to return.
     * @return The startTips at the given index.
     */
    java.lang.String getStartTips(int index);
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param index The index of the element to return.
     * @return The startTips at the given index.
     */
    com.google.protobuf.ByteString
        getStartTipsBytes(int index);

    /**
     * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
     * @return The sequenceSize.
     */
    int getSequenceSize();
  }
  /**
   * Protobuf type {@code dsepractice.chinese.v1alpha1.GameSessionData.Paragraph}
   */
  public  static final class Paragraph extends
      com.google.protobuf.GeneratedMessageLite<
          Paragraph, Paragraph.Builder> implements
      // @@protoc_insertion_point(message_implements:dsepractice.chinese.v1alpha1.GameSessionData.Paragraph)
      ParagraphOrBuilder {
    private Paragraph() {
      segments_ = com.google.protobuf.GeneratedMessageLite.emptyProtobufList();
      optionsSequence_ = emptyProtobufList();
      startTips_ = com.google.protobuf.GeneratedMessageLite.emptyProtobufList();
    }
    public static final int SEGMENTS_FIELD_NUMBER = 1;
    private com.google.protobuf.Internal.ProtobufList<java.lang.String> segments_;
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @return A list containing the segments.
     */
    @java.lang.Override
    public java.util.List<java.lang.String> getSegmentsList() {
      return segments_;
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @return The count of segments.
     */
    @java.lang.Override
    public int getSegmentsCount() {
      return segments_.size();
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param index The index of the element to return.
     * @return The segments at the given index.
     */
    @java.lang.Override
    public java.lang.String getSegments(int index) {
      return segments_.get(index);
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param index The index of the value to return.
     * @return The bytes of the segments at the given index.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getSegmentsBytes(int index) {
      return com.google.protobuf.ByteString.copyFromUtf8(
          segments_.get(index));
    }
    private void ensureSegmentsIsMutable() {
      com.google.protobuf.Internal.ProtobufList<java.lang.String> tmp =
          segments_;  if (!tmp.isModifiable()) {
        segments_ =
            com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
       }
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param index The index to set the value at.
     * @param value The segments to set.
     */
    private void setSegments(
        int index, java.lang.String value) {
      java.lang.Class<?> valueClass = value.getClass();
  ensureSegmentsIsMutable();
      segments_.set(index, value);
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param value The segments to add.
     */
    private void addSegments(
        java.lang.String value) {
      java.lang.Class<?> valueClass = value.getClass();
  ensureSegmentsIsMutable();
      segments_.add(value);
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param values The segments to add.
     */
    private void addAllSegments(
        java.lang.Iterable<java.lang.String> values) {
      ensureSegmentsIsMutable();
      com.google.protobuf.AbstractMessageLite.addAll(
          values, segments_);
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     */
    private void clearSegments() {
      segments_ = com.google.protobuf.GeneratedMessageLite.emptyProtobufList();
    }
    /**
     * <code>repeated string segments = 1 [json_name = "segments"];</code>
     * @param value The bytes of the segments to add.
     */
    private void addSegmentsBytes(
        com.google.protobuf.ByteString value) {
      checkByteStringIsUtf8(value);
      ensureSegmentsIsMutable();
      segments_.add(value.toStringUtf8());
    }

    public static final int OPTIONS_SEQUENCE_FIELD_NUMBER = 2;
    private com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> optionsSequence_;
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    @java.lang.Override
    public java.util.List<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> getOptionsSequenceList() {
      return optionsSequence_;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    public java.util.List<? extends gg.dsepractice.chinese.v1alpha1.GameSessionData.OptionOrBuilder> 
        getOptionsSequenceOrBuilderList() {
      return optionsSequence_;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    @java.lang.Override
    public int getOptionsSequenceCount() {
      return optionsSequence_.size();
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    @java.lang.Override
    public gg.dsepractice.chinese.v1alpha1.GameSessionData.Option getOptionsSequence(int index) {
      return optionsSequence_.get(index);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    public gg.dsepractice.chinese.v1alpha1.GameSessionData.OptionOrBuilder getOptionsSequenceOrBuilder(
        int index) {
      return optionsSequence_.get(index);
    }
    private void ensureOptionsSequenceIsMutable() {
      com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> tmp = optionsSequence_;
      if (!tmp.isModifiable()) {
        optionsSequence_ =
            com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
       }
    }

    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    private void setOptionsSequence(
        int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Option value) {
      value.getClass();
  ensureOptionsSequenceIsMutable();
      optionsSequence_.set(index, value);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    private void addOptionsSequence(gg.dsepractice.chinese.v1alpha1.GameSessionData.Option value) {
      value.getClass();
  ensureOptionsSequenceIsMutable();
      optionsSequence_.add(value);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    private void addOptionsSequence(
        int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Option value) {
      value.getClass();
  ensureOptionsSequenceIsMutable();
      optionsSequence_.add(index, value);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    private void addAllOptionsSequence(
        java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> values) {
      ensureOptionsSequenceIsMutable();
      com.google.protobuf.AbstractMessageLite.addAll(
          values, optionsSequence_);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    private void clearOptionsSequence() {
      optionsSequence_ = emptyProtobufList();
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
     */
    private void removeOptionsSequence(int index) {
      ensureOptionsSequenceIsMutable();
      optionsSequence_.remove(index);
    }

    public static final int START_TIPS_FIELD_NUMBER = 3;
    private com.google.protobuf.Internal.ProtobufList<java.lang.String> startTips_;
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @return A list containing the startTips.
     */
    @java.lang.Override
    public java.util.List<java.lang.String> getStartTipsList() {
      return startTips_;
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @return The count of startTips.
     */
    @java.lang.Override
    public int getStartTipsCount() {
      return startTips_.size();
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param index The index of the element to return.
     * @return The startTips at the given index.
     */
    @java.lang.Override
    public java.lang.String getStartTips(int index) {
      return startTips_.get(index);
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param index The index of the value to return.
     * @return The bytes of the startTips at the given index.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getStartTipsBytes(int index) {
      return com.google.protobuf.ByteString.copyFromUtf8(
          startTips_.get(index));
    }
    private void ensureStartTipsIsMutable() {
      com.google.protobuf.Internal.ProtobufList<java.lang.String> tmp =
          startTips_;  if (!tmp.isModifiable()) {
        startTips_ =
            com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
       }
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param index The index to set the value at.
     * @param value The startTips to set.
     */
    private void setStartTips(
        int index, java.lang.String value) {
      java.lang.Class<?> valueClass = value.getClass();
  ensureStartTipsIsMutable();
      startTips_.set(index, value);
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param value The startTips to add.
     */
    private void addStartTips(
        java.lang.String value) {
      java.lang.Class<?> valueClass = value.getClass();
  ensureStartTipsIsMutable();
      startTips_.add(value);
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param values The startTips to add.
     */
    private void addAllStartTips(
        java.lang.Iterable<java.lang.String> values) {
      ensureStartTipsIsMutable();
      com.google.protobuf.AbstractMessageLite.addAll(
          values, startTips_);
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     */
    private void clearStartTips() {
      startTips_ = com.google.protobuf.GeneratedMessageLite.emptyProtobufList();
    }
    /**
     * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
     * @param value The bytes of the startTips to add.
     */
    private void addStartTipsBytes(
        com.google.protobuf.ByteString value) {
      checkByteStringIsUtf8(value);
      ensureStartTipsIsMutable();
      startTips_.add(value.toStringUtf8());
    }

    public static final int SEQUENCE_SIZE_FIELD_NUMBER = 4;
    private int sequenceSize_;
    /**
     * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
     * @return The sequenceSize.
     */
    @java.lang.Override
    public int getSequenceSize() {
      return sequenceSize_;
    }
    /**
     * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
     * @param value The sequenceSize to set.
     */
    private void setSequenceSize(int value) {
      
      sequenceSize_ = value;
    }
    /**
     * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
     */
    private void clearSequenceSize() {
      
      sequenceSize_ = 0;
    }

    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return parseDelimitedFrom(DEFAULT_INSTANCE, input);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input, extensionRegistry);
    }

    public static Builder newBuilder() {
      return (Builder) DEFAULT_INSTANCE.createBuilder();
    }
    public static Builder newBuilder(gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph prototype) {
      return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
    }

    /**
     * Protobuf type {@code dsepractice.chinese.v1alpha1.GameSessionData.Paragraph}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageLite.Builder<
          gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, Builder> implements
        // @@protoc_insertion_point(builder_implements:dsepractice.chinese.v1alpha1.GameSessionData.Paragraph)
        gg.dsepractice.chinese.v1alpha1.GameSessionData.ParagraphOrBuilder {
      // Construct using gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.newBuilder()
      private Builder() {
        super(DEFAULT_INSTANCE);
      }


      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @return A list containing the segments.
       */
      @java.lang.Override
      public java.util.List<java.lang.String>
          getSegmentsList() {
        return java.util.Collections.unmodifiableList(
            instance.getSegmentsList());
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @return The count of segments.
       */
      @java.lang.Override
      public int getSegmentsCount() {
        return instance.getSegmentsCount();
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param index The index of the element to return.
       * @return The segments at the given index.
       */
      @java.lang.Override
      public java.lang.String getSegments(int index) {
        return instance.getSegments(index);
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param index The index of the value to return.
       * @return The bytes of the segments at the given index.
       */
      @java.lang.Override
      public com.google.protobuf.ByteString
          getSegmentsBytes(int index) {
        return instance.getSegmentsBytes(index);
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param index The index to set the value at.
       * @param value The segments to set.
       * @return This builder for chaining.
       */
      public Builder setSegments(
          int index, java.lang.String value) {
        copyOnWrite();
        instance.setSegments(index, value);
        return this;
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param value The segments to add.
       * @return This builder for chaining.
       */
      public Builder addSegments(
          java.lang.String value) {
        copyOnWrite();
        instance.addSegments(value);
        return this;
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param values The segments to add.
       * @return This builder for chaining.
       */
      public Builder addAllSegments(
          java.lang.Iterable<java.lang.String> values) {
        copyOnWrite();
        instance.addAllSegments(values);
        return this;
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @return This builder for chaining.
       */
      public Builder clearSegments() {
        copyOnWrite();
        instance.clearSegments();
        return this;
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param value The bytes of the segments to add.
       * @return This builder for chaining.
       */
      public Builder addSegmentsBytes(
          com.google.protobuf.ByteString value) {
        copyOnWrite();
        instance.addSegmentsBytes(value);
        return this;
      }

      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      @java.lang.Override
      public java.util.List<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> getOptionsSequenceList() {
        return java.util.Collections.unmodifiableList(
            instance.getOptionsSequenceList());
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      @java.lang.Override
      public int getOptionsSequenceCount() {
        return instance.getOptionsSequenceCount();
      }/**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      @java.lang.Override
      public gg.dsepractice.chinese.v1alpha1.GameSessionData.Option getOptionsSequence(int index) {
        return instance.getOptionsSequence(index);
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder setOptionsSequence(
          int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Option value) {
        copyOnWrite();
        instance.setOptionsSequence(index, value);
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder setOptionsSequence(
          int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.Builder builderForValue) {
        copyOnWrite();
        instance.setOptionsSequence(index,
            builderForValue.build());
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder addOptionsSequence(gg.dsepractice.chinese.v1alpha1.GameSessionData.Option value) {
        copyOnWrite();
        instance.addOptionsSequence(value);
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder addOptionsSequence(
          int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Option value) {
        copyOnWrite();
        instance.addOptionsSequence(index, value);
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder addOptionsSequence(
          gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.Builder builderForValue) {
        copyOnWrite();
        instance.addOptionsSequence(builderForValue.build());
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder addOptionsSequence(
          int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.Builder builderForValue) {
        copyOnWrite();
        instance.addOptionsSequence(index,
            builderForValue.build());
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder addAllOptionsSequence(
          java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> values) {
        copyOnWrite();
        instance.addAllOptionsSequence(values);
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder clearOptionsSequence() {
        copyOnWrite();
        instance.clearOptionsSequence();
        return this;
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      public Builder removeOptionsSequence(int index) {
        copyOnWrite();
        instance.removeOptionsSequence(index);
        return this;
      }

      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @return A list containing the startTips.
       */
      @java.lang.Override
      public java.util.List<java.lang.String>
          getStartTipsList() {
        return java.util.Collections.unmodifiableList(
            instance.getStartTipsList());
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @return The count of startTips.
       */
      @java.lang.Override
      public int getStartTipsCount() {
        return instance.getStartTipsCount();
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param index The index of the element to return.
       * @return The startTips at the given index.
       */
      @java.lang.Override
      public java.lang.String getStartTips(int index) {
        return instance.getStartTips(index);
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param index The index of the value to return.
       * @return The bytes of the startTips at the given index.
       */
      @java.lang.Override
      public com.google.protobuf.ByteString
          getStartTipsBytes(int index) {
        return instance.getStartTipsBytes(index);
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param index The index to set the value at.
       * @param value The startTips to set.
       * @return This builder for chaining.
       */
      public Builder setStartTips(
          int index, java.lang.String value) {
        copyOnWrite();
        instance.setStartTips(index, value);
        return this;
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param value The startTips to add.
       * @return This builder for chaining.
       */
      public Builder addStartTips(
          java.lang.String value) {
        copyOnWrite();
        instance.addStartTips(value);
        return this;
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param values The startTips to add.
       * @return This builder for chaining.
       */
      public Builder addAllStartTips(
          java.lang.Iterable<java.lang.String> values) {
        copyOnWrite();
        instance.addAllStartTips(values);
        return this;
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @return This builder for chaining.
       */
      public Builder clearStartTips() {
        copyOnWrite();
        instance.clearStartTips();
        return this;
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param value The bytes of the startTips to add.
       * @return This builder for chaining.
       */
      public Builder addStartTipsBytes(
          com.google.protobuf.ByteString value) {
        copyOnWrite();
        instance.addStartTipsBytes(value);
        return this;
      }

      /**
       * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
       * @return The sequenceSize.
       */
      @java.lang.Override
      public int getSequenceSize() {
        return instance.getSequenceSize();
      }
      /**
       * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
       * @param value The sequenceSize to set.
       * @return This builder for chaining.
       */
      public Builder setSequenceSize(int value) {
        copyOnWrite();
        instance.setSequenceSize(value);
        return this;
      }
      /**
       * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
       * @return This builder for chaining.
       */
      public Builder clearSequenceSize() {
        copyOnWrite();
        instance.clearSequenceSize();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:dsepractice.chinese.v1alpha1.GameSessionData.Paragraph)
    }
    @java.lang.Override
    @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
    protected final java.lang.Object dynamicMethod(
        com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
        java.lang.Object arg0, java.lang.Object arg1) {
      switch (method) {
        case NEW_MUTABLE_INSTANCE: {
          return new gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph();
        }
        case NEW_BUILDER: {
          return new Builder();
        }
        case BUILD_MESSAGE_INFO: {
            java.lang.Object[] objects = new java.lang.Object[] {
              "segments_",
              "optionsSequence_",
              gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.class,
              "startTips_",
              "sequenceSize_",
            };
            java.lang.String info =
                "\u0000\u0004\u0000\u0000\u0001\u0004\u0004\u0000\u0003\u0000\u0001\u021a\u0002\u001b" +
                "\u0003\u021a\u0004\u0004";
            return newMessageInfo(DEFAULT_INSTANCE, info, objects);
        }
        // fall through
        case GET_DEFAULT_INSTANCE: {
          return DEFAULT_INSTANCE;
        }
        case GET_PARSER: {
          com.google.protobuf.Parser<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph> parser = PARSER;
          if (parser == null) {
            synchronized (gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.class) {
              parser = PARSER;
              if (parser == null) {
                parser =
                    new DefaultInstanceBasedParser<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph>(
                        DEFAULT_INSTANCE);
                PARSER = parser;
              }
            }
          }
          return parser;
      }
      case GET_MEMOIZED_IS_INITIALIZED: {
        return (byte) 1;
      }
      case SET_MEMOIZED_IS_INITIALIZED: {
        return null;
      }
      }
      throw new UnsupportedOperationException();
    }


    // @@protoc_insertion_point(class_scope:dsepractice.chinese.v1alpha1.GameSessionData.Paragraph)
    private static final gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph DEFAULT_INSTANCE;
    static {
      Paragraph defaultInstance = new Paragraph();
      // New instances are implicitly immutable so no need to make
      // immutable.
      DEFAULT_INSTANCE = defaultInstance;
      com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
        Paragraph.class, defaultInstance);
    }

    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static volatile com.google.protobuf.Parser<Paragraph> PARSER;

    public static com.google.protobuf.Parser<Paragraph> parser() {
      return DEFAULT_INSTANCE.getParserForType();
    }
  }

  public interface OptionOrBuilder extends
      // @@protoc_insertion_point(interface_extends:dsepractice.chinese.v1alpha1.GameSessionData.Option)
      com.google.protobuf.MessageLiteOrBuilder {

    /**
     * <code>string content = 1 [json_name = "content"];</code>
     * @return The content.
     */
    java.lang.String getContent();
    /**
     * <code>string content = 1 [json_name = "content"];</code>
     * @return The bytes for content.
     */
    com.google.protobuf.ByteString
        getContentBytes();

    /**
     * <code>int32 position = 2 [json_name = "position"];</code>
     * @return The position.
     */
    int getPosition();
  }
  /**
   * Protobuf type {@code dsepractice.chinese.v1alpha1.GameSessionData.Option}
   */
  public  static final class Option extends
      com.google.protobuf.GeneratedMessageLite<
          Option, Option.Builder> implements
      // @@protoc_insertion_point(message_implements:dsepractice.chinese.v1alpha1.GameSessionData.Option)
      OptionOrBuilder {
    private Option() {
      content_ = "";
    }
    public static final int CONTENT_FIELD_NUMBER = 1;
    private java.lang.String content_;
    /**
     * <code>string content = 1 [json_name = "content"];</code>
     * @return The content.
     */
    @java.lang.Override
    public java.lang.String getContent() {
      return content_;
    }
    /**
     * <code>string content = 1 [json_name = "content"];</code>
     * @return The bytes for content.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getContentBytes() {
      return com.google.protobuf.ByteString.copyFromUtf8(content_);
    }
    /**
     * <code>string content = 1 [json_name = "content"];</code>
     * @param value The content to set.
     */
    private void setContent(
        java.lang.String value) {
      java.lang.Class<?> valueClass = value.getClass();
  
      content_ = value;
    }
    /**
     * <code>string content = 1 [json_name = "content"];</code>
     */
    private void clearContent() {
      
      content_ = getDefaultInstance().getContent();
    }
    /**
     * <code>string content = 1 [json_name = "content"];</code>
     * @param value The bytes for content to set.
     */
    private void setContentBytes(
        com.google.protobuf.ByteString value) {
      checkByteStringIsUtf8(value);
      content_ = value.toStringUtf8();
      
    }

    public static final int POSITION_FIELD_NUMBER = 2;
    private int position_;
    /**
     * <code>int32 position = 2 [json_name = "position"];</code>
     * @return The position.
     */
    @java.lang.Override
    public int getPosition() {
      return position_;
    }
    /**
     * <code>int32 position = 2 [json_name = "position"];</code>
     * @param value The position to set.
     */
    private void setPosition(int value) {
      
      position_ = value;
    }
    /**
     * <code>int32 position = 2 [json_name = "position"];</code>
     */
    private void clearPosition() {
      
      position_ = 0;
    }

    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, data, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return parseDelimitedFrom(DEFAULT_INSTANCE, input);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input);
    }
    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageLite.parseFrom(
          DEFAULT_INSTANCE, input, extensionRegistry);
    }

    public static Builder newBuilder() {
      return (Builder) DEFAULT_INSTANCE.createBuilder();
    }
    public static Builder newBuilder(gg.dsepractice.chinese.v1alpha1.GameSessionData.Option prototype) {
      return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
    }

    /**
     * Protobuf type {@code dsepractice.chinese.v1alpha1.GameSessionData.Option}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageLite.Builder<
          gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, Builder> implements
        // @@protoc_insertion_point(builder_implements:dsepractice.chinese.v1alpha1.GameSessionData.Option)
        gg.dsepractice.chinese.v1alpha1.GameSessionData.OptionOrBuilder {
      // Construct using gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.newBuilder()
      private Builder() {
        super(DEFAULT_INSTANCE);
      }


      /**
       * <code>string content = 1 [json_name = "content"];</code>
       * @return The content.
       */
      @java.lang.Override
      public java.lang.String getContent() {
        return instance.getContent();
      }
      /**
       * <code>string content = 1 [json_name = "content"];</code>
       * @return The bytes for content.
       */
      @java.lang.Override
      public com.google.protobuf.ByteString
          getContentBytes() {
        return instance.getContentBytes();
      }
      /**
       * <code>string content = 1 [json_name = "content"];</code>
       * @param value The content to set.
       * @return This builder for chaining.
       */
      public Builder setContent(
          java.lang.String value) {
        copyOnWrite();
        instance.setContent(value);
        return this;
      }
      /**
       * <code>string content = 1 [json_name = "content"];</code>
       * @return This builder for chaining.
       */
      public Builder clearContent() {
        copyOnWrite();
        instance.clearContent();
        return this;
      }
      /**
       * <code>string content = 1 [json_name = "content"];</code>
       * @param value The bytes for content to set.
       * @return This builder for chaining.
       */
      public Builder setContentBytes(
          com.google.protobuf.ByteString value) {
        copyOnWrite();
        instance.setContentBytes(value);
        return this;
      }

      /**
       * <code>int32 position = 2 [json_name = "position"];</code>
       * @return The position.
       */
      @java.lang.Override
      public int getPosition() {
        return instance.getPosition();
      }
      /**
       * <code>int32 position = 2 [json_name = "position"];</code>
       * @param value The position to set.
       * @return This builder for chaining.
       */
      public Builder setPosition(int value) {
        copyOnWrite();
        instance.setPosition(value);
        return this;
      }
      /**
       * <code>int32 position = 2 [json_name = "position"];</code>
       * @return This builder for chaining.
       */
      public Builder clearPosition() {
        copyOnWrite();
        instance.clearPosition();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:dsepractice.chinese.v1alpha1.GameSessionData.Option)
    }
    @java.lang.Override
    @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
    protected final java.lang.Object dynamicMethod(
        com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
        java.lang.Object arg0, java.lang.Object arg1) {
      switch (method) {
        case NEW_MUTABLE_INSTANCE: {
          return new gg.dsepractice.chinese.v1alpha1.GameSessionData.Option();
        }
        case NEW_BUILDER: {
          return new Builder();
        }
        case BUILD_MESSAGE_INFO: {
            java.lang.Object[] objects = new java.lang.Object[] {
              "content_",
              "position_",
            };
            java.lang.String info =
                "\u0000\u0002\u0000\u0000\u0001\u0002\u0002\u0000\u0000\u0000\u0001\u0208\u0002\u0004" +
                "";
            return newMessageInfo(DEFAULT_INSTANCE, info, objects);
        }
        // fall through
        case GET_DEFAULT_INSTANCE: {
          return DEFAULT_INSTANCE;
        }
        case GET_PARSER: {
          com.google.protobuf.Parser<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option> parser = PARSER;
          if (parser == null) {
            synchronized (gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.class) {
              parser = PARSER;
              if (parser == null) {
                parser =
                    new DefaultInstanceBasedParser<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option>(
                        DEFAULT_INSTANCE);
                PARSER = parser;
              }
            }
          }
          return parser;
      }
      case GET_MEMOIZED_IS_INITIALIZED: {
        return (byte) 1;
      }
      case SET_MEMOIZED_IS_INITIALIZED: {
        return null;
      }
      }
      throw new UnsupportedOperationException();
    }


    // @@protoc_insertion_point(class_scope:dsepractice.chinese.v1alpha1.GameSessionData.Option)
    private static final gg.dsepractice.chinese.v1alpha1.GameSessionData.Option DEFAULT_INSTANCE;
    static {
      Option defaultInstance = new Option();
      // New instances are implicitly immutable so no need to make
      // immutable.
      DEFAULT_INSTANCE = defaultInstance;
      com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
        Option.class, defaultInstance);
    }

    public static gg.dsepractice.chinese.v1alpha1.GameSessionData.Option getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static volatile com.google.protobuf.Parser<Option> PARSER;

    public static com.google.protobuf.Parser<Option> parser() {
      return DEFAULT_INSTANCE.getParserForType();
    }
  }

  public static final int PARAGRAPHS_FIELD_NUMBER = 1;
  private com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph> paragraphs_;
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  @java.lang.Override
  public java.util.List<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph> getParagraphsList() {
    return paragraphs_;
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  public java.util.List<? extends gg.dsepractice.chinese.v1alpha1.GameSessionData.ParagraphOrBuilder> 
      getParagraphsOrBuilderList() {
    return paragraphs_;
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  @java.lang.Override
  public int getParagraphsCount() {
    return paragraphs_.size();
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  @java.lang.Override
  public gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph getParagraphs(int index) {
    return paragraphs_.get(index);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  public gg.dsepractice.chinese.v1alpha1.GameSessionData.ParagraphOrBuilder getParagraphsOrBuilder(
      int index) {
    return paragraphs_.get(index);
  }
  private void ensureParagraphsIsMutable() {
    com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph> tmp = paragraphs_;
    if (!tmp.isModifiable()) {
      paragraphs_ =
          com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
     }
  }

  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  private void setParagraphs(
      int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph value) {
    value.getClass();
  ensureParagraphsIsMutable();
    paragraphs_.set(index, value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  private void addParagraphs(gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph value) {
    value.getClass();
  ensureParagraphsIsMutable();
    paragraphs_.add(value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  private void addParagraphs(
      int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph value) {
    value.getClass();
  ensureParagraphsIsMutable();
    paragraphs_.add(index, value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  private void addAllParagraphs(
      java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph> values) {
    ensureParagraphsIsMutable();
    com.google.protobuf.AbstractMessageLite.addAll(
        values, paragraphs_);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  private void clearParagraphs() {
    paragraphs_ = emptyProtobufList();
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
   */
  private void removeParagraphs(int index) {
    ensureParagraphsIsMutable();
    paragraphs_.remove(index);
  }

  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.GameSessionData parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }

  public static Builder newBuilder() {
    return (Builder) DEFAULT_INSTANCE.createBuilder();
  }
  public static Builder newBuilder(gg.dsepractice.chinese.v1alpha1.GameSessionData prototype) {
    return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
  }

  /**
   * Protobuf type {@code dsepractice.chinese.v1alpha1.GameSessionData}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageLite.Builder<
        gg.dsepractice.chinese.v1alpha1.GameSessionData, Builder> implements
      // @@protoc_insertion_point(builder_implements:dsepractice.chinese.v1alpha1.GameSessionData)
      gg.dsepractice.chinese.v1alpha1.GameSessionDataOrBuilder {
    // Construct using gg.dsepractice.chinese.v1alpha1.GameSessionData.newBuilder()
    private Builder() {
      super(DEFAULT_INSTANCE);
    }


    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    @java.lang.Override
    public java.util.List<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph> getParagraphsList() {
      return java.util.Collections.unmodifiableList(
          instance.getParagraphsList());
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    @java.lang.Override
    public int getParagraphsCount() {
      return instance.getParagraphsCount();
    }/**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    @java.lang.Override
    public gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph getParagraphs(int index) {
      return instance.getParagraphs(index);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder setParagraphs(
        int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph value) {
      copyOnWrite();
      instance.setParagraphs(index, value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder setParagraphs(
        int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.Builder builderForValue) {
      copyOnWrite();
      instance.setParagraphs(index,
          builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder addParagraphs(gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph value) {
      copyOnWrite();
      instance.addParagraphs(value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder addParagraphs(
        int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph value) {
      copyOnWrite();
      instance.addParagraphs(index, value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder addParagraphs(
        gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.Builder builderForValue) {
      copyOnWrite();
      instance.addParagraphs(builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder addParagraphs(
        int index, gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.Builder builderForValue) {
      copyOnWrite();
      instance.addParagraphs(index,
          builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder addAllParagraphs(
        java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph> values) {
      copyOnWrite();
      instance.addAllParagraphs(values);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder clearParagraphs() {
      copyOnWrite();
      instance.clearParagraphs();
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    public Builder removeParagraphs(int index) {
      copyOnWrite();
      instance.removeParagraphs(index);
      return this;
    }

    // @@protoc_insertion_point(builder_scope:dsepractice.chinese.v1alpha1.GameSessionData)
  }
  @java.lang.Override
  @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
  protected final java.lang.Object dynamicMethod(
      com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
      java.lang.Object arg0, java.lang.Object arg1) {
    switch (method) {
      case NEW_MUTABLE_INSTANCE: {
        return new gg.dsepractice.chinese.v1alpha1.GameSessionData();
      }
      case NEW_BUILDER: {
        return new Builder();
      }
      case BUILD_MESSAGE_INFO: {
          java.lang.Object[] objects = new java.lang.Object[] {
            "paragraphs_",
            gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.class,
          };
          java.lang.String info =
              "\u0000\u0001\u0000\u0000\u0001\u0001\u0001\u0000\u0001\u0000\u0001\u001b";
          return newMessageInfo(DEFAULT_INSTANCE, info, objects);
      }
      // fall through
      case GET_DEFAULT_INSTANCE: {
        return DEFAULT_INSTANCE;
      }
      case GET_PARSER: {
        com.google.protobuf.Parser<gg.dsepractice.chinese.v1alpha1.GameSessionData> parser = PARSER;
        if (parser == null) {
          synchronized (gg.dsepractice.chinese.v1alpha1.GameSessionData.class) {
            parser = PARSER;
            if (parser == null) {
              parser =
                  new DefaultInstanceBasedParser<gg.dsepractice.chinese.v1alpha1.GameSessionData>(
                      DEFAULT_INSTANCE);
              PARSER = parser;
            }
          }
        }
        return parser;
    }
    case GET_MEMOIZED_IS_INITIALIZED: {
      return (byte) 1;
    }
    case SET_MEMOIZED_IS_INITIALIZED: {
      return null;
    }
    }
    throw new UnsupportedOperationException();
  }


  // @@protoc_insertion_point(class_scope:dsepractice.chinese.v1alpha1.GameSessionData)
  private static final gg.dsepractice.chinese.v1alpha1.GameSessionData DEFAULT_INSTANCE;
  static {
    GameSessionData defaultInstance = new GameSessionData();
    // New instances are implicitly immutable so no need to make
    // immutable.
    DEFAULT_INSTANCE = defaultInstance;
    com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
      GameSessionData.class, defaultInstance);
  }

  public static gg.dsepractice.chinese.v1alpha1.GameSessionData getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static volatile com.google.protobuf.Parser<GameSessionData> PARSER;

  public static com.google.protobuf.Parser<GameSessionData> parser() {
    return DEFAULT_INSTANCE.getParserForType();
  }
}

